package data;
import java.util.*;
import static helper.Global.*;
import static helper.Functions.*;
import structure.Structures.*;
/**
 * This class contains the methods to generate the instances for CRS system.
 */

public class Instance {
    public static void main(String[] args){
        System.out.println("Program Start...");
        List<String[]> rawDataType1 = readDataCSV(baseDir+"stype1DemandPool.csv");
        rawDataType1 = rawDataType1.subList(3,rawDataType1.size()-1);
        List<String[]> rawDataType2 = readDataCSV(baseDir+"type2DemandPool.csv");
        rawDataType2 = rawDataType2.subList(3,rawDataType2.size()-1);

        int nType1 = 2;
        int nType2 = 3;
        int nVehicle = (int) (0.5* nType1);
        String fileName = "c" + nType1 + "-r" + nType2 + "-k" + nVehicle;
        for(int i = 0; i < 5; i++) {
            generateInstance("s"+fileName+"-n"+i, rawDataType1, rawDataType2, nType1, nType2, nVehicle);
        }

    }

    public static void generateInstance(String fileName, List<String[]> type1Pool, List<String[]> type2Pool, int nType1, int nType2, int nVehicle){
        List<Type1> type1List = new ArrayList<>(nType1);
        List<Type2> type2List = new ArrayList<>(nType2);
        for(int i = 0; i < nType1; i++){
            Type1 temp = new Type1(type1Pool.get(random(type1Pool.size())));
            type1List.add(temp);
        }
        for(int i = 0; i < nType2; i++){
            Type2 temp = new Type2(type2Pool.get(random(type2Pool.size())));
            type2List.add(temp);
        }
        ArrayList<String> output = new ArrayList<>();
        output.add(fileName);
        output.add("nVehicle," + nVehicle);
        output.add("Type 1 Demand Count,"+nType1);
        output.add("origin, destination, startTime, startTimeDriveOther, endTime");
        for(Type1 e : type1List){
            int[] temp = {e.origin, e.destin, e.start, e.startD, e.end};
            output.add(combineStringCSV(temp));
        }
        output.add("Type 2 Demand Count,"+nType2);
        output.add("origin, destination, openTimeWindow, closeTimeWindow");
        for(Type2 e : type2List){
            int[] temp = {e.origin, e.destin, e.tw_a, e.tw_b};
            output.add(combineStringCSV(temp));
        }
        String folderName = "c" + nType1 + "-r" + nType2 + "-k" + nVehicle+"/";
        writeDataCSV(instanceDir+"s"+folderName,fileName, output);
    }
}
