package data;
import structure.Structures;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.lang.Object.*;
import org.apache.commons.math3.distribution.GammaDistribution;
import static helper.Functions.*;
import static helper.Global.*;
public class Scenario {
    public static void main(String[] args){
        System.out.println("Program Start...");
        List<String[]> rawData = readDataCSV(baseDir+"base.csv");
        rawData = rawData.subList(9,rawData.size());
        int size = rawData.size();
        System.out.println(size);
        double[][] travelMatrix = new double[size][size];
        for(int i = 0; i < size; i++){
            for (int j = 0; j < size; j++){
                travelMatrix[i][j] = Double.parseDouble(rawData.get(i)[j]);
            }
            //System.out.println(Arrays.toString(travelMatrix[i]));
        }
        generateBase(travelMatrix);
//        System.out.println(nextGamma());
        generateSample(travelMatrix, 2000);
    }

    public static void generateBase(double[][] matrix){
        ArrayList<String> output = new ArrayList<>();
        output.add("base scenario, in seconds");
        output.add("nLocation,"+matrix.length);
        double[][] temp = new double[matrix.length][matrix.length];
        for (int i = 0; i < matrix.length; i++)
            for (int j = 0; j < matrix.length; j++) {
                temp[i][j] = Math.ceil(matrix[i][j] * 1.0 / 60) ;
            }
        for(int i =0; i < matrix.length; i++){
            output.add(Arrays.toString(temp[i]).replace("[", "").replace("]", ""));
        }
        writeDataCSV(scenarioDir,"base", output);
    }

    public static void generateSample(double[][] matrix, int num){
        for(int k = 0; k < num; k++) {
            ArrayList<String> output = new ArrayList<>();
            output.add("Scenario "+k+", in minutes");
            output.add("nLocation,"+matrix.length);
            double[][] temp = new double[matrix.length][matrix.length];
            //System.out.println(Arrays.toString(matrix[0]));
            GammaDistribution gammaDist = new GammaDistribution(0.2, 1);
            for (int i = 0; i < matrix.length; i++)
                for (int j = 0; j < matrix.length; j++) {
                    temp[i][j] = Math.ceil(matrix[i][j]  * (0.8 + gammaDist.sample())/60.0) ;
                }
            for (int i = 0; i < matrix.length; i++) {
                output.add(Arrays.toString(temp[i]).replace("[", "").replace("]", ""));
            }

            writeDataCSV(scenarioDir, Integer.toString(k), output);
        }
    }


}
